import 'package:cramr_ui_lib/widgets/evalutation_row.dart';
import 'package:flutter/material.dart';
import 'package:flutter_test/flutter_test.dart';

final List<String> _randomIndicative = [
  'exp1',
  'exp2',
  'exp3',
  'exp4',
  'exp5',
  'exp6',
];

final List<String> _randomPronouns = [
  'pron1',
  'pron2',
  'pron3',
  'pron4',
  'pron5',
  'pron6',
];

main() {
  testWidgets('test right answer', (WidgetTester tester) async {
    const int defaultPerson = 0;
    await tester.pumpWidget(MaterialApp(
      home: Scaffold(
        body: EvaluationRow(defaultPerson, 'fr', _randomPronouns[defaultPerson],
            _randomIndicative[defaultPerson], _randomIndicative[defaultPerson]),
      ),
    ));
    Finder indicativeFinder = find.text(_randomIndicative[defaultPerson]);
    expect(indicativeFinder, findsOneWidget);
  });

  testWidgets('test wrong answer', (WidgetTester tester) async {
    const int defaultPerson = 0;
    const int wrongPerson = 1;
    await tester.pumpWidget(MaterialApp(
      home: Scaffold(
        body: EvaluationRow(defaultPerson, 'fr', _randomPronouns[defaultPerson],
            _randomIndicative[wrongPerson], _randomIndicative[defaultPerson]),
      ),
    ));
    Finder indicativeFinder = find.text(_randomIndicative[wrongPerson]);
    expect(indicativeFinder, findsOneWidget);
    //TODO: test for presence of error icon
  });
}
